<template>
  <div>
    <b-form-group
      v-if="parameter.type === 'string+boolean'"
      v-slot="{ ariaDescribedby }"
      class="mb-0"
      :class="{ 'form-control is-invalid': $v[parameter.key].$invalid }"
      :disabled="disabled"
    >
      <b-form-radio-group
        v-model="$v[parameter.key].$model"
        :options="options"
        :aria-describedby="ariaDescribedby"
        v-bind="addProperties(parameter, BFormRadioGroup)"
        @change="updateInput"
      ></b-form-radio-group>
    </b-form-group>
  </div>
</template>

<script>
import { BFormRadioGroup } from 'bootstrap-vue';
export default {
  props: {
    parameter: {
      type: Object,
      default: () => {},
    },
    disabled: {
      type: Boolean,
      default: () => false,
    },
    updateValue: {
      type: Function,
      default: () => ({}),
    },
    validations: {
      type: Function,
      default: () => ({}),
    },
    changeStateScenario: {
      type: Function,
      default: () => ({}),
    },
    addProperties: {
      type: Function,
      default: () => ({}),
    },
  },
  data() {
    return {
      options: [
        { text: 'Both', value: 'both' },
        { text: 'Yes', value: '1' },
        { text: 'No', value: '0' },
      ],
      BFormRadioGroup: null,
      [this.parameter.key]: 'both',
    };
  },
  computed: {
    param() {
      return this.$nuxt.context.store.state.parameters.inputMap[
        this.parameter.key
      ];
    },
  },
  watch: {
    // Changes on the action
    param() {
      this[this.parameter.key] = this.getParamValue();
    },
  },
  mounted() {
    this.BFormRadioGroup = BFormRadioGroup;
    if (this.$v[this.parameter.key].$invalid) {
      this.changeStateScenario(this.parameter.key, true);
    }
  },
  beforeMount() {
    this[this.parameter.key] = this.getParamValue();
  },
  validations() {
    return this.validations(this.parameter);
  },
  methods: {
    getParamValue() {
      let value = 'both';
      if (this.param.value != null && this.param.value !== undefined) {
        // The next condition is to avoid an error on the validation
        // if the parameter is required because this.param.value is empty
        // and the library assume that it's an error.
        if (this.param.value === '') {
          value = 'both';
        } else {
          value = this.param.value.toString();
        }
      } else if (this.param.default) {
        value = this.param.default;
      }
      return value;
    },
    async updateInput(value) {
      if (this.disabled) return;
      if (!this.$v[this.parameter.key].$error) {
        this.changeStateScenario(this.parameter.key, false);
        await this.updateValue(this.parameter.key, value.replace('both', ''));
      } else {
        this.changeStateScenario(this.parameter.key, true);
      }
    },
  },
};
</script>
